/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-pr2-plugs-msgs-1.0.21-0precise-20150327-1925/msg/OutletPose.msg
 *
 */


#ifndef PR2_PLUGS_MSGS_MESSAGE_OUTLETPOSE_H
#define PR2_PLUGS_MSGS_MESSAGE_OUTLETPOSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <geometry_msgs/Pose.h>
#include <geometry_msgs/Pose.h>

namespace pr2_plugs_msgs
{
template <class ContainerAllocator>
struct OutletPose_
{
  typedef OutletPose_<ContainerAllocator> Type;

  OutletPose_()
    : name()
    , id()
    , approach_pose()
    , outlet_pose()  {
    }
  OutletPose_(const ContainerAllocator& _alloc)
    : name(_alloc)
    , id(_alloc)
    , approach_pose(_alloc)
    , outlet_pose(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _name_type;
  _name_type name;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _id_type;
  _id_type id;

   typedef  ::geometry_msgs::Pose_<ContainerAllocator>  _approach_pose_type;
  _approach_pose_type approach_pose;

   typedef  ::geometry_msgs::Pose_<ContainerAllocator>  _outlet_pose_type;
  _outlet_pose_type outlet_pose;




  typedef boost::shared_ptr< ::pr2_plugs_msgs::OutletPose_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::pr2_plugs_msgs::OutletPose_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct OutletPose_

typedef ::pr2_plugs_msgs::OutletPose_<std::allocator<void> > OutletPose;

typedef boost::shared_ptr< ::pr2_plugs_msgs::OutletPose > OutletPosePtr;
typedef boost::shared_ptr< ::pr2_plugs_msgs::OutletPose const> OutletPoseConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::pr2_plugs_msgs::OutletPose_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::pr2_plugs_msgs::OutletPose_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace pr2_plugs_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'pr2_plugs_msgs': ['/tmp/buildd/ros-hydro-pr2-plugs-msgs-1.0.21-0precise-20150327-1925/msg', '/tmp/buildd/ros-hydro-pr2-plugs-msgs-1.0.21-0precise-20150327-1925/obj-x86_64-linux-gnu/devel/share/pr2_plugs_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::pr2_plugs_msgs::OutletPose_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::pr2_plugs_msgs::OutletPose_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_plugs_msgs::OutletPose_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_plugs_msgs::OutletPose_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_plugs_msgs::OutletPose_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_plugs_msgs::OutletPose_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::pr2_plugs_msgs::OutletPose_<ContainerAllocator> >
{
  static const char* value()
  {
    return "962a9be0b14920e512bb14af60d77e96";
  }

  static const char* value(const ::pr2_plugs_msgs::OutletPose_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x962a9be0b14920e5ULL;
  static const uint64_t static_value2 = 0x12bb14af60d77e96ULL;
};

template<class ContainerAllocator>
struct DataType< ::pr2_plugs_msgs::OutletPose_<ContainerAllocator> >
{
  static const char* value()
  {
    return "pr2_plugs_msgs/OutletPose";
  }

  static const char* value(const ::pr2_plugs_msgs::OutletPose_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::pr2_plugs_msgs::OutletPose_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string name\n\
string id\n\
geometry_msgs/Pose approach_pose\n\
geometry_msgs/Pose outlet_pose\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
";
  }

  static const char* value(const ::pr2_plugs_msgs::OutletPose_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::pr2_plugs_msgs::OutletPose_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.name);
      stream.next(m.id);
      stream.next(m.approach_pose);
      stream.next(m.outlet_pose);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct OutletPose_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::pr2_plugs_msgs::OutletPose_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::pr2_plugs_msgs::OutletPose_<ContainerAllocator>& v)
  {
    s << indent << "name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.name);
    s << indent << "id: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.id);
    s << indent << "approach_pose: ";
    s << std::endl;
    Printer< ::geometry_msgs::Pose_<ContainerAllocator> >::stream(s, indent + "  ", v.approach_pose);
    s << indent << "outlet_pose: ";
    s << std::endl;
    Printer< ::geometry_msgs::Pose_<ContainerAllocator> >::stream(s, indent + "  ", v.outlet_pose);
  }
};

} // namespace message_operations
} // namespace ros

#endif // PR2_PLUGS_MSGS_MESSAGE_OUTLETPOSE_H
