/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-pr2-plugs-msgs-1.0.21-0precise-20150327-1925/msg/RechargeState.msg
 *
 */


#ifndef PR2_PLUGS_MSGS_MESSAGE_RECHARGESTATE_H
#define PR2_PLUGS_MSGS_MESSAGE_RECHARGESTATE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace pr2_plugs_msgs
{
template <class ContainerAllocator>
struct RechargeState_
{
  typedef RechargeState_<ContainerAllocator> Type;

  RechargeState_()
    : state(0)  {
    }
  RechargeState_(const ContainerAllocator& _alloc)
    : state(0)  {
    }



   typedef int32_t _state_type;
  _state_type state;


    enum { WAITING_FOR_STATE = 0 };
     enum { UNPLUGGED = 1 };
     enum { PLUGGED_IN = 2 };
     enum { FAILED = 3 };
 

  typedef boost::shared_ptr< ::pr2_plugs_msgs::RechargeState_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::pr2_plugs_msgs::RechargeState_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct RechargeState_

typedef ::pr2_plugs_msgs::RechargeState_<std::allocator<void> > RechargeState;

typedef boost::shared_ptr< ::pr2_plugs_msgs::RechargeState > RechargeStatePtr;
typedef boost::shared_ptr< ::pr2_plugs_msgs::RechargeState const> RechargeStateConstPtr;

// constants requiring out of line definition

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::pr2_plugs_msgs::RechargeState_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::pr2_plugs_msgs::RechargeState_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace pr2_plugs_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'pr2_plugs_msgs': ['/tmp/buildd/ros-hydro-pr2-plugs-msgs-1.0.21-0precise-20150327-1925/msg', '/tmp/buildd/ros-hydro-pr2-plugs-msgs-1.0.21-0precise-20150327-1925/obj-x86_64-linux-gnu/devel/share/pr2_plugs_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::pr2_plugs_msgs::RechargeState_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::pr2_plugs_msgs::RechargeState_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_plugs_msgs::RechargeState_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_plugs_msgs::RechargeState_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_plugs_msgs::RechargeState_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_plugs_msgs::RechargeState_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::pr2_plugs_msgs::RechargeState_<ContainerAllocator> >
{
  static const char* value()
  {
    return "5de4a394889646148ec9431b39d7a2b8";
  }

  static const char* value(const ::pr2_plugs_msgs::RechargeState_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x5de4a39488964614ULL;
  static const uint64_t static_value2 = 0x8ec9431b39d7a2b8ULL;
};

template<class ContainerAllocator>
struct DataType< ::pr2_plugs_msgs::RechargeState_<ContainerAllocator> >
{
  static const char* value()
  {
    return "pr2_plugs_msgs/RechargeState";
  }

  static const char* value(const ::pr2_plugs_msgs::RechargeState_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::pr2_plugs_msgs::RechargeState_<ContainerAllocator> >
{
  static const char* value()
  {
    return "int32 state\n\
int32 WAITING_FOR_STATE = 0\n\
int32 UNPLUGGED = 1\n\
int32 PLUGGED_IN = 2\n\
int32 FAILED = 3\n\
";
  }

  static const char* value(const ::pr2_plugs_msgs::RechargeState_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::pr2_plugs_msgs::RechargeState_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.state);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct RechargeState_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::pr2_plugs_msgs::RechargeState_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::pr2_plugs_msgs::RechargeState_<ContainerAllocator>& v)
  {
    s << indent << "state: ";
    Printer<int32_t>::stream(s, indent + "  ", v.state);
  }
};

} // namespace message_operations
} // namespace ros

#endif // PR2_PLUGS_MSGS_MESSAGE_RECHARGESTATE_H
