/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-pr2-plugs-msgs-1.0.21-0precise-20150327-1925/obj-x86_64-linux-gnu/devel/share/pr2_plugs_msgs/msg/VisionOutletDetectionGoal.msg
 *
 */


#ifndef PR2_PLUGS_MSGS_MESSAGE_VISIONOUTLETDETECTIONGOAL_H
#define PR2_PLUGS_MSGS_MESSAGE_VISIONOUTLETDETECTIONGOAL_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <geometry_msgs/PoseStamped.h>
#include <geometry_msgs/Vector3Stamped.h>

namespace pr2_plugs_msgs
{
template <class ContainerAllocator>
struct VisionOutletDetectionGoal_
{
  typedef VisionOutletDetectionGoal_<ContainerAllocator> Type;

  VisionOutletDetectionGoal_()
    : camera_name()
    , prior()
    , wall_normal()  {
    }
  VisionOutletDetectionGoal_(const ContainerAllocator& _alloc)
    : camera_name(_alloc)
    , prior(_alloc)
    , wall_normal(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _camera_name_type;
  _camera_name_type camera_name;

   typedef  ::geometry_msgs::PoseStamped_<ContainerAllocator>  _prior_type;
  _prior_type prior;

   typedef  ::geometry_msgs::Vector3Stamped_<ContainerAllocator>  _wall_normal_type;
  _wall_normal_type wall_normal;




  typedef boost::shared_ptr< ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct VisionOutletDetectionGoal_

typedef ::pr2_plugs_msgs::VisionOutletDetectionGoal_<std::allocator<void> > VisionOutletDetectionGoal;

typedef boost::shared_ptr< ::pr2_plugs_msgs::VisionOutletDetectionGoal > VisionOutletDetectionGoalPtr;
typedef boost::shared_ptr< ::pr2_plugs_msgs::VisionOutletDetectionGoal const> VisionOutletDetectionGoalConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace pr2_plugs_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'pr2_plugs_msgs': ['/tmp/buildd/ros-hydro-pr2-plugs-msgs-1.0.21-0precise-20150327-1925/msg', '/tmp/buildd/ros-hydro-pr2-plugs-msgs-1.0.21-0precise-20150327-1925/obj-x86_64-linux-gnu/devel/share/pr2_plugs_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "e01805506b7947845c6db890b01b4876";
  }

  static const char* value(const ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xe01805506b794784ULL;
  static const uint64_t static_value2 = 0x5c6db890b01b4876ULL;
};

template<class ContainerAllocator>
struct DataType< ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "pr2_plugs_msgs/VisionOutletDetectionGoal";
  }

  static const char* value(const ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
string camera_name\n\
geometry_msgs/PoseStamped prior\n\
geometry_msgs/Vector3Stamped wall_normal\n\
\n\
================================================================================\n\
MSG: geometry_msgs/PoseStamped\n\
# A Pose with reference coordinate frame and timestamp\n\
Header header\n\
Pose pose\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3Stamped\n\
# This represents a Vector3 with reference coordinate frame and timestamp\n\
Header header\n\
Vector3 vector\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
";
  }

  static const char* value(const ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.camera_name);
      stream.next(m.prior);
      stream.next(m.wall_normal);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct VisionOutletDetectionGoal_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::pr2_plugs_msgs::VisionOutletDetectionGoal_<ContainerAllocator>& v)
  {
    s << indent << "camera_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.camera_name);
    s << indent << "prior: ";
    s << std::endl;
    Printer< ::geometry_msgs::PoseStamped_<ContainerAllocator> >::stream(s, indent + "  ", v.prior);
    s << indent << "wall_normal: ";
    s << std::endl;
    Printer< ::geometry_msgs::Vector3Stamped_<ContainerAllocator> >::stream(s, indent + "  ", v.wall_normal);
  }
};

} // namespace message_operations
} // namespace ros

#endif // PR2_PLUGS_MSGS_MESSAGE_VISIONOUTLETDETECTIONGOAL_H
